//+------------------------------------------------------------------+
//|                                    Trend_Reversal_and_Runner.mq4 |
//|                 Copyright  2006, Metatradertools Software Corp. |
//|                                   http://www.metatradertools.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Metatradertools Software Corp."
#property link      "http://www.metatradertools.net"

string NameEA       = "Trend_Reversal_and_Runner";
int MagicEA         = 20060906;

// External variables

extern int eSlippage                 =  2;             // Slippage
extern int eAttemptsToAction         =  5;             // Attempts to OpenOrder or CloseOrder actions
extern int eBarShift                 =  1;             // Bar shift for cross condition

extern double eSL=0;             // Stop loss
extern double eTP1=2;            // Take profit
extern double eTP2=6;            // Take profit
extern double eTP3=10;           // Take profit
extern double eLots=4;           // Lots to trade
extern double eTP1Lots=2;        // Lots for close
extern double eTP2Lots=1;        // Lots for close

extern int eMA1Period                =  12;
extern int eMA1Mode                  =  MODE_EMA;      //MODE_SMA(0) Simple, MODE_EMA(1) Exponential, MODE_SMMA(2) Smoothed, MODE_LWMA(3) Linear weighted. 
extern int eMA1Price                 =  PRICE_CLOSE;   //PRICE_CLOSE(0) Close price. PRICE_OPEN(1) Open price. PRICE_HIGH(2) High price. PRICE_LOW(3) Low price. PRICE_MEDIAN(4) Median price, (high+low)/2. PRICE_TYPICAL(5) Typical price, (high+low+close)/3. PRICE_WEIGHTED(6) Weighted close price, (high+low+close+close)/4. 

extern int eMA2Period                =  52;
extern int eMA2Mode                  =  MODE_EMA;      //MODE_SMA(0) Simple, MODE_EMA(1) Exponential, MODE_SMMA(2) Smoothed, MODE_LWMA(3) Linear weighted. 
extern int eMA2Price                 =  PRICE_CLOSE;   //PRICE_CLOSE(0) Close price. PRICE_OPEN(1) Open price. PRICE_HIGH(2) High price. PRICE_LOW(3) Low price. PRICE_MEDIAN(4) Median price, (high+low)/2. PRICE_TYPICAL(5) Typical price, (high+low+close)/3. PRICE_WEIGHTED(6) Weighted close price, (high+low+close+close)/4. 

extern int eTEMA1Period              =  25;
extern int eMA3Price                 =  PRICE_CLOSE;   //PRICE_CLOSE(0) Close price. PRICE_OPEN(1) Open price. PRICE_HIGH(2) High price. PRICE_LOW(3) Low price. PRICE_MEDIAN(4) Median price, (high+low)/2. PRICE_TYPICAL(5) Typical price, (high+low+close)/3. PRICE_WEIGHTED(6) Weighted close price, (high+low+close+close)/4. 

// Internal variables
double MA11;
double MA10;

double MA21;
double MA20;

double TEMA11;
double TEMA10;

bool isOrdered;
//+------------------------------------------------------------------+
int start()
{
   CalculateIndicatorValues();
       
   while(true)
   {
      if (CollectOrderData())
         break;  
   }
  
   if (!isOrdered)
      if (CheckForBUY())
         if (CheckForMoney())
            if (OpenBUY())
               isOrdered=true;
   if (!isOrdered)
      if (CheckForSELL())
         if (CheckForMoney())
            if (OpenSELL())
               isOrdered=true;
   return(0);
}
//+------------------------------------------------------------------+
bool CollectOrderData()
{
   int TotalOrders=OrdersTotal();
   int i;
   // 
   int CloseResult=0;
   int ModifyResult=0;
    //
   isOrdered=false;
   double Profit;
   double LotSize;
   
   for (i=0;i<TotalOrders;i++) 
   {
      OrderSelect(i, SELECT_BY_POS,MODE_TRADES);
      if((OrderSymbol()==Symbol())&&(OrderMagicNumber()==MagicEA))
      {
         if (OrderType()==OP_BUY)
         {
            if (CheckForCloseBUY())
               if (CloseOrder(OrderTicket(),OrderLots()))
               {
                  Alert("Order was closed");
                  CloseResult++;
                  break;
               }
            LotSize=OrderLots();
            Profit=(Bid-OrderOpenPrice())/Point;
            if ((LotSize==eLots)&&(Profit>=eTP1))
            {
               CloseOrder(OrderTicket(),eTP1Lots);
               Alert("Order was partially closed due to TP1");
               CloseResult++;
               break;
            }
            if ((LotSize==eLots-eTP1Lots)&&(Profit>=eTP2))
            {
               CloseOrder(OrderTicket(),eTP2Lots);
               Alert("Order was partially closed due to TP2");
               CloseResult++;
               break;
            }
         } else if (OrderType()==OP_SELL)
         {
            if (CheckForCloseSELL())
            {
               if (CloseOrder(OrderTicket(),OrderLots()))
               {
                  Alert("Order was closed");
                  CloseResult++;
                  break;
               }
            }
            LotSize=OrderLots();
            Profit=(OrderOpenPrice()-Ask)/Point;
            if ((LotSize==eLots)&&(Profit>=eTP1))
            {
               CloseOrder(OrderTicket(),eTP1Lots);
               Alert("Order was partially closed due to TP1");
               CloseResult++;
               break;
            }
            if ((LotSize==eLots-eTP1Lots)&&(Profit>=eTP2))
            {
               CloseOrder(OrderTicket(),eTP2Lots);
               Alert("Order was partially closed due to TP2");
               CloseResult++;
               break;
            }
         }
      }
   }
   if (CloseResult>0)
      return(false);
   TotalOrders=OrdersTotal();
   for (i=0;i<TotalOrders;i++) 
   {
      OrderSelect(i, SELECT_BY_POS,MODE_TRADES);
      if((OrderSymbol()==Symbol())&&(OrderMagicNumber()==MagicEA))
         isOrdered=true;
   }
   return(true);
}

void CalculateIndicatorValues()
{
   MA11=iMA(NULL,0,eMA1Period,0,eMA1Mode,eMA1Price,eBarShift+1);
   MA10=iMA(NULL,0,eMA1Period,0,eMA1Mode,eMA1Price,eBarShift);
   
   MA21=iMA(NULL,0,eMA2Period,0,eMA2Mode,eMA2Price,eBarShift+1);
   MA20=iMA(NULL,0,eMA2Period,0,eMA2Mode,eMA2Price,eBarShift);
   
   TEMA11=iCustom(Symbol(),0,"TEMA2",25,0,eBarShift+1);
   TEMA10=iCustom(Symbol(),0,"TEMA2",25,0,eBarShift);
}

bool CheckForBUY()
{
   bool Result=false;

   bool Cond1=false;
   bool Cond2=false;
   
   bool CrossCond1=false; // EMA1 cross EMA2
   bool CrossCond2=false; // TEMA1 cross EMA2
   
   // Cross condition
   if ((MA11<MA21)&&(MA10>MA20))
         CrossCond1=true;
         
   if ((TEMA11<MA21)&&(TEMA10>MA20))
         CrossCond2=true;
      
   // Cond to position
   if (MA10>MA20)
      Cond1=true;
   if (TEMA10>MA20)
      Cond2=true;

   if (Cond1&&Cond2&&(CrossCond1||CrossCond2))
      Result=true;

   if (Result) 
   {
      Alert ("For  BUY:EMA11="+MA11+" EMA21="+MA21+" EMA10="+MA10+" EMA20="+MA20);
      Alert ("For  BUY:TEMA11="+TEMA11+" EMA21="+MA21+" TEMA10="+TEMA10+" EMA20="+MA20);
      
      if (CrossCond1) Alert("For  BUY:12EMA cross condition");
      if (CrossCond2) Alert("For  BUY:25TEMA cross condition");
   }
   return(Result);
}
bool CheckForSELL()
{
   bool Result=false;

   bool Cond1=false;
   bool Cond2=false;
   
   bool CrossCond1=false; // EMA1 cross EMA2
   bool CrossCond2=false; // TEMA1 cross EMA2
   
   // Cross condition
   if ((MA11>MA21)&&(MA10<MA20))
         CrossCond1=true;
         
   if ((TEMA11>MA21)&&(TEMA10<MA20))
         CrossCond2=true;
      
   // Cond to position
   if (MA10<MA20)
      Cond1=true;
   if (TEMA10<MA20)
      Cond2=true;

   if (Cond1&&Cond2&&(CrossCond1||CrossCond2))
      Result=true;

   if (Result) 
   {
      Alert ("For  SELL:EMA11="+MA11+" EMA21="+MA21+" EMA10="+MA10+" EMA20="+MA20);
      Alert ("For  SELL:TEMA11="+TEMA11+" EMA21="+MA21+" TEMA10="+TEMA10+" EMA20="+MA20);
      
      if (CrossCond1) Alert("For  SELL:12EMA cross condition");
      if (CrossCond2) Alert("For  SELL:25TEMA cross condition");
   }
   return(Result);
}
bool OpenBUY()
{
   bool Result=false;

   if (StartOrder(OP_BUY,eLots,Ask,eSL,eTP3,"",Blue))
      Result=true;

   return(Result);
}

bool OpenSELL()
{
   bool Result=false;

   if (StartOrder(OP_SELL,eLots,Bid,eSL,eTP3,"",Red))
      Result=true;

   return(Result);
}

bool CheckForCloseBUY()
{
   bool Result=false;
   if ((MA10<MA20)||(TEMA10<MA20))
      Result=true;
   return(Result);
}

bool CheckForCloseSELL()
{
   bool Result=false;
   if ((MA10>MA20)||(TEMA10>MA20))
      Result=true;
   return(Result);
}
bool StartOrder(int OrderOp,double Lots,double OrderPrice,double vSL,double vTP,string Comm,int OrderColor)
{
   bool Result=false;
   double SL;
   double TP;
   int Error;
   int Try=0;
   while(true)
   {
      Try++;
      Error=0;
      SL=vSL;
      TP=vTP;
      if (OrderOp==OP_BUY)
      {
         if(SL>0) SL=Ask-SL*Point;
         if(TP>0) TP=Ask+TP*Point;
      } else if (OrderOp==OP_SELL)
      {
         if(SL>0) SL=Bid+SL*Point;
         if(TP>0) TP=Bid-TP*Point;
      }
      Alert("Order: Symbol="+Symbol()+" lots="+Lots+" OpenPrice="+OrderPrice+" Slippage="+eSlippage+" SL="+SL+" TP="+TP);
      if (!IsTradeContextBusy())
      {
         int Ticket=OrderSend(Symbol(),OrderOp,NormalizeDouble(Lots,Digits),NormalizeDouble(OrderPrice,Digits),eSlippage,NormalizeDouble(SL,Digits),NormalizeDouble(TP,Digits),Comm,MagicEA,0,OrderColor);
         if (Ticket<0)
            Error=GetLastError();
         if (Error!=0)
         {
            Alert("Open Order error="+Error);
            RefreshRates();
            if (OrderOp==OP_BUY)
               OrderPrice=Ask;
            else if (OrderOp==OP_SELL)
               OrderPrice=Bid;
         } else
         {
            Result=true;
            break;
         }
      } else Sleep(1000);
      if (Try>eAttemptsToAction)
         break;
   }
   return (Result);   
}
bool CloseOrder(int Ticket, double Lot)
{
   bool   Result;
   double Price;
   int Cmd;
   int Error;
   int Try;
   if(OrderSelect(Ticket,SELECT_BY_TICKET,MODE_TRADES))
   {
      Cmd=OrderType();
      if(Cmd==OP_BUY || Cmd==OP_SELL)
      {
         Try=0;
         while(true)
         {
            if(Cmd==OP_BUY) Price=Bid;
            else            Price=Ask;
            Result=OrderClose(OrderTicket(),NormalizeDouble(Lot,Digits),Price,eSlippage,CLR_NONE);
            if(Result!=TRUE)
            { 
               Error=GetLastError(); 
               Print("LastError = ",Error); 
            }
            else 
               Error=0;
            if(Error==135) 
               RefreshRates();
            else 
               break;
            Try++;
            if (Try>eAttemptsToAction)
               break;
         }
      }
   }
   else Alert(Symbol()+" Error when order select ", GetLastError());
   return(Result);
}

bool CheckForMoney()
{
   bool Result=false;
   if(AccountFreeMargin()>=1000*eLots) 
      Result=true;
   return(Result);
}
